<template>
  <canvas id="Background-Canvas" height="667" class="bg-01" style="max-width: 100%; overflow: hidden"></canvas>
</template>

<script>
  import Wave from './Wave.js';
  export default {
    name: "backgroundCanvas",
    data() {
      return {
        translateYValue: 0,
        currentOffsetTop: 0,
      }
    },
    mounted() {
      var vendors = ['ms', 'moz', 'webkit', 'o'];
      for(var x = 0; x < vendors.length && !window.requestAnimationFrame; ++x) {
          window.requestAnimationFrame = window[vendors[x]+'RequestAnimationFrame'];
          window.cancelAnimationFrame = window[vendors[x]+'CancelAnimationFrame'] ||
          window[vendors[x]+'CancelRequestAnimationFrame'];
      }
      let bg = {
        initFunc : function(){
          // get width window & some
          let windowWidth = window.innerWidth;
          this.myCanvas = document.querySelector('#Background-Canvas'),
          this.ctx = this.myCanvas.getContext('2d');
          this.ctx.globalCompositeOperation = "source-over";
          this.myCanvas.width = windowWidth;
          //
          // define color for waves
          this.grd1 = this.ctx.createLinearGradient(0, 0, this.myCanvas.width, this.myCanvas.height);
          // this.grd1=this.ctx.createLinearGradient(1140.0 * this.myCanvas.width / 1280.0, this.myCanvas.height, 1260.0*this.myCanvas.width/1280.0, 74.0 * this.myCanvas.height/728.0);

          // this.grd1.addColorStop(0,"#181a3a");
          // this.grd1.addColorStop(0.5, '#231E4F');
          // this.grd1.addColorStop(1, '#271E4A');
          this.grd1.addColorStop(0,"#181a3a");
          this.grd1.addColorStop(0.5,"rgba(161, 68, 207, 0.63)");
          this.grd1.addColorStop(1,"#3023AE");
          this.timeNow = this.timeExecute = new Date().getTime();
        },
        drawFunc : function(){
          this.timeNow = new Date().getTime();
          if (this.timeNow - this.timeExecute >=30) {
            this.ctx.clearRect(0, 0, this.myCanvas.width, this.myCanvas.height);
            this.wave1.render();
            this.timeExecute = this.timeNow;
          };
          window.requestAnimationFrame(this.drawFunc);
        },
        start : function(){
          this.initFunc = this.initFunc.bind(this);
          this.drawFunc = this.drawFunc.bind(this);

          let t = new Promise((resolve, reject)=>{
            this.initFunc();
            this.wave1 = new Wave(this.myCanvas, this.grd1);
            resolve();
          });
          t.then(()=>{
            this.drawFunc();
          })
        }
      }
      bg.start();
    },
    created() {
      window.addEventListener('scroll', this.handleScroll);
    }
  }
</script>

<style>
  #Background-Canvas {
    opacity: 0.2;
  }
</style>
